//
//  DNSCacheEntry.h
//  GlowWorm
//
//  Created by Curtis Jones on 2006.07.12.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <GlowWormObject.h>
#import <Transaction.h>


@interface DNSCacheEntry : NSObject <GlowWormObject>
{
	
}

- (id)initWithName:(NSString *)aName andAddrs:(NSArray *)addrs;
- (void)dealloc;

- (BOOL)addAddr:(NSNumber *)anAddr;
- (void)replaceAddrs:(NSArray *)addrs;
- (void)clear;

- (NSDate *)lastLookup;
- (void)updateLastLookupTime;
- (BOOL)hasAddr:(NSNumber *)anAddr;
- (NSString *)name;
- (int)count;

- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;

@end





@interface AddrTrans : Transaction
{
	
}

- (id)initWithMesg:(GlowWormMesg *)aMesg andAddr:(DNSCacheEntry *)aDce;
- (void)dealloc;

@end
