//
//  GlowWormObject.h
//  GlowWorm
//
//  Created by Curtis Jones on 2006.09.16.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol GlowWormObject
- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;
@end

@interface GlowWormObject : NSObject <NSCoding>
{
	
}

- (id)init;
- (id)initWithValues:(NSDictionary *)values;
- (void)dealloc;

- (NSDictionary *)values;
- (void)setValues:(NSDictionary *)values;

- (NSObject *)objectForKey:(NSObject *)aKey;
- (void)setObject:(NSObject *)anObj forKey:(NSObject *)aKey;

- (int)serializeString:(NSMutableData *)data forKey:(NSString *)aKey;
- (int)serializeBinary:(NSMutableData *)data forKey:(NSString *)aKey;
- (int)serializeUint16:(NSMutableData *)data forKey:(NSString *)aKey;
- (int)serializeUint32:(NSMutableData *)data forKey:(NSString *)aKey;
- (int)serializeUint64:(NSMutableData *)data forKey:(NSString *)aKey;
- (int)deserializeString:(NSData *)data offs:(int)offs forKey:(NSString *)aKey;
- (int)deserializeBinary:(NSData *)data offs:(int)offs forKey:(NSString *)aKey;
- (int)deserializeUint16:(NSData *)data offs:(int)offs forKey:(NSString *)aKey;
- (int)deserializeUint32:(NSData *)data offs:(int)offs forKey:(NSString *)aKey;
- (int)deserializeUint64:(NSData *)data offs:(int)offs forKey:(NSString *)aKey;

+ (int)hton16:(NSMutableData *)data value:(uint16_t)num;
+ (int)hton32:(NSMutableData *)data value:(uint32_t)num;
+ (int)hton64:(NSMutableData *)data value:(uint64_t)num;
+ (int)ntoh16:(NSData *)data offs:(int)offs value:(uint16_t *)num;
+ (int)ntoh32:(NSData *)data offs:(int)offs value:(uint32_t *)num;
+ (int)ntoh64:(NSData *)data offs:(int)offs value:(uint64_t *)num;

@end
