//
//  GlowWormSyst.h
//  GlowWorm
//
//  Created by Curtis Jones on 2007.01.23.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <GlowWormObject.h>
#import <Transaction.h>

@interface GlowWormSyst : GlowWormObject <GlowWormObject>
{
	
}

- (NSNumber *)ctrl;
- (NSNumber *)tran;
- (NSData *)data;
- (NSDictionary *)userList;
- (NSDictionary *)groupList;

- (void)setCtrl:(NSNumber *)aNum;
- (void)setTran:(NSNumber *)aNum;
- (void)setData:(NSData *)aStr;
- (void)setUserList:(NSDictionary *)aList;
- (void)setGroupList:(NSDictionary *)aList;

+ (Transaction *)systInsertUserHandler:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)systInsertGroupHandler:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)systDeleteHandler:(id)callbackObj callbackSel:(SEL)callbackSel;
+ (Transaction *)systAuthorize:(uint32_t)aKctlId withTimeout:(uint32_t)aTimeout callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)systDeauthorize:(uint32_t)aKctlId callbackObj:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)systSelectUserList:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)systSelectGroupList:(id)callbackObj callbackSel:(SEL)callbackSel callbackCtx:(id)callbackCtx;
+ (Transaction *)systReplyWithUserList:(Transaction *)aTrans userList:(NSDictionary *)aList;
+ (Transaction *)systReplyWithGroupList:(Transaction *)aTrans groupList:(NSDictionary *)aList;

- (NSData *)serialize;
- (int)deserialize:(NSData *)data offs:(int)offs;

@end
